# 第 12 周 ChatGPT 支持插件

本周本想换个主题，但与 AI 有关的新闻实在是太多了，令人无法忽略。

首先是国外博主 AI Explained 在 OpenAI 发表的[关于他们的 GPT-4 的技术论文中发现了 9 条隐藏的线索](https://bag.frp.aqzscn.cn/share/641d8cc40a1f48.41496169)。这些线索包括 GPT-5 可能已经被训练出来了，GPT-4 在自然环境中经历过自身“挂掉”的情况，OpenAI 呼吁对 AI 行业进行有效监管，以及他们承诺帮助接近实现 AGI 的公司。

> `AGI`指普遍比人类更聪明，并且有益于全人类的人工智能系统。OpenAI 的这个承诺是不是预示着未来只会有一家公司掌握着最先进的人工智能技术呢？

![](https://bag.frp.aqzscn.cn/assets/images/c/c/ccb45ab0/9b27781c.jpeg)

OpenAI 还聘请了超级预测员来预测与 GPT-4 相关的风险，并开发了一个基于规则的奖励模型来教会 GPT-4 拒绝某些原则。

该博主指出，OpenAI 对加速 AI 开发进程的担忧似乎与微软的信念背道而驰。作者还强调了一项基准测试，表明 GPT-4 在常识推理方面已达到人类水平。

这边还在预测着呢，[OpenAI 就又悄咪咪发布了 ChatGPT Plugins](https://bag.frp.aqzscn.cn/share/641d8bdf346057.83544187)，允许 ChatGPT 连接第三方应用程序，充当 AI App Store。这些插件改进了 ChatGPT 的功能，并允许与开发人员定义的 API 进行自然语言交互。他们可以让 ChatGPT 访问实时信息、执行工作流、检索知识库信息等。这些插件的出现也可能会扰乱基于模型的初创公司，因为 **OpenAI 的框架更快、更安全、更好**。

![](https://bag.frp.aqzscn.cn/assets/images/2/0/20c45a67/d6a5033c.png)

这一刻可以比作**人工智能的寒武纪大爆发**，因为当 ChatGPT 拥有了联网的能力（通过插件），拥有了连接其他应用的能力，以它目前的智能程度，真的就拥有了无限可能。

[GitHub 也在本周发布了 Copilot X](https://bag.frp.aqzscn.cn/share/641d8c57531452.87268484)，这是一款智能编程助手，将 OpenAI 聊天功能整合到其编码工具中，允许程序员询问如何完成某些编码任务。 Copilot X 是之前 GitHub Copilot 的升级版，在代码编辑器中增加了聊天界面，使聊天机器人能够识别和解释代码，并提供修改建议和错误修复。

![](https://bag.frp.aqzscn.cn/assets/images/8/a/8ab25f04/2de91235.png)

新工具不仅可以自动完成代码和注释，还可以通过聊天和语音与开发人员沟通，帮助他们使用 OpenAI 最新的 GPT-4 模型理解、修改、测试和优化代码。 Copilot X 目前在 Microsoft Visual Studio 和 Visual Studio Code 中可用，而且 GitHub 计划在未来将其扩展到其他 IDE。

> 目前需要通过[https://github.com/github-copilot/chat_waitlist_signup](https://github.com/github-copilot/chat_waitlist_signup)链接加入等待列表才能使用，我已经等不及啦！！！

看过了人工智能在文字方面的新进展后，图像生成领域也迎来新的突破：[Midjourney 的最新版本 V5 以其能够为人物、物体甚至整个电影场景创建无可挑剔的逼真画作而在网上引起轩然大波](https://bag.frp.aqzscn.cn/share/641d8c84679a59.24881925)。即使是最熟练的人类画家、演员和模特也无法获得 Midjourney 的卓越输出。

![](https://bag.frp.aqzscn.cn/assets/images/c/9/c9e41dae/ffec3788.png)

V5 版本以惊人的速度发展，具有更高的图像质量、更多的输出种类、更广泛的样式、无缝纹理支持、更宽的宽高比、更好的图像提示和更宽的动态范围。 **V5 版本甚至解决了之前关于 AI 无法绘制手指或创建逼真的玻璃反射的批评**。升级版使用户能够自定义图像权重和宽高比，现在**需要更详细的提示才能生成最佳输出**。 V5 版本的改进为用户提供了对创作过程的更多控制，以产生真实且有凝聚力的输出。

最后，[百度的文心一言云服务将于 3 月 27 日上线](https://bag.frp.aqzscn.cn/share/641d8ca8aef8a1.72301296)，在此之前，不妨读一读[比尔盖茨对这个新的 AI 时代的看法](https://bag.frp.aqzscn.cn/share/641d8c761123a9.17499490)。

> 本周百度的文心一格算是出尽了风头，只不过是不好的风头。要求画个总线，结果出了个公交车，因为总线的英文是`Bus`，要求画个起重机，结果出了只鹤，因为起重机的英文是`crane`，这个单词有鹤的意思。从这种蛛丝马迹其实看不出百度的这个产品是不是调别人接口的壳子，但一定不是最懂中文的人工智能。

## 🎵 本周歌曲

[不要在我寂寞的时候说爱我 - T.R.Y](https://music.163.com/song?id=26600299)

<iframe frameborder="no" width="330px" height="86px" src="//music.163.com/outchain/player?type=2&id=26600299&height=66"></iframe>

## 📺 消息

### [英国《金融时报》称，瑞银正在洽谈收购陷入困境的瑞士竞争对手瑞士信贷](https://bag.frp.aqzscn.cn/share/641c8634b32943.23145015)

![](https://bag.frp.aqzscn.cn/assets/images/9/8/98f07402/4c88908b.jpeg)

据报道，在未能稳定陷入困境的银行的救助失败后，瑞银正在就收购瑞士信贷的全部或部分进行谈判。虽然瑞士监管机构鼓励瑞士信贷和瑞银合并，但两家银行最初都不愿意进行。自美国银行硅谷银行和 Signature Bank 最近倒闭以来，瑞士信贷是受市场动荡打击的最大银行。欧洲央行临时监事会开会讨论银行业的压力和波动性，消息人士透露，整个欧元区的存款保持稳定，而对瑞士信贷的敞口并不大。

### [欧洲央行呼吁进一步加息以对抗顽固的通货膨胀](https://bag.frp.aqzscn.cn/share/641c85a179f1f0.43212003)

![](https://cloudfront-us-east-2.images.arcpublishing.com/reuters/KC56ENRCQZOORFOY4V3H76325A.jpg)

欧洲央行决策管理委员会的两位主要鹰派人士表示，欧洲央行可能需要进一步提高利率以对抗持续的通胀。奥地利和比利时央行行长回应了斯洛伐克和立陶宛央行行长的评论，强调在欧元区 8.5% 的通胀率下加息的必要性。欧洲央行周四将利率上调 50 个基点，同时预计到 2025 年通货膨胀率将保持在 2% 的目标之上。尽管对美国两家银行倒闭和瑞士信贷出现问题后银行业出现动荡感到担忧，但霍尔兹曼认为另一场全球金融危机的风险。

> 银行一个个都快顶不住了还加息，虽然我不懂，但感觉像慢性死亡……

### [日韩顶级企业推动留下艰难历史](https://bag.frp.aqzscn.cn/share/641c85fcdfc372.61575932)

![](https://bag.frp.aqzscn.cn/assets/images/2/a/2abdf218/1519bbf7.jpeg)

日本和韩国商界领袖已同意在芯片和技术方面进行合作，以缓解因战时暴行而造成的紧张关系。这是韩国领导人时隔 12 年首次访问东京。美国渴望结成统一战线来应对中国日益增长的实力和朝鲜的导弹计划所构成的威胁，因此一直在改善与这两个国家的商业外交。韩国总统尹锡烈表示，日本和韩国可以在半导体、电池和电动汽车方面进行合作。然而，有人担心两国之间的战时历史可能会阻碍进展。

> 外国媒体提起日本在韩国的暴行，举的例子竟然是强迫劳动，难道不应该举最严重的行为吗？所以身而为人，总是立场先行。

### [乌干达国会议员通过对同性恋判处死刑的法案](https://bag.frp.aqzscn.cn/share/641c85edbd1968.42438816)

![](https://bag.frp.aqzscn.cn/assets/images/2/a/2a0aefd9/c0a54c86.jpeg)

乌干达议会通过了一项反 LGBTQ+ 法案，该法案将对同性恋行为判处死刑，并对同性“活动”进行“招募、提拔和资助”。 389 名立法者中只有两名 Fox Odoi-Oywelowo 和 Paul Kwizera Bucyana 反对该法案，该法案并未为法规或立法框架增加任何新价值。乌干达总统约韦里·穆塞韦尼可以否决或签署该法案成为法律。穆塞韦尼最近似乎对该法案表示支持，这标志着非洲 LGBTQ+ 权利的一系列挫折中的最新一次。同性恋在大多数非洲国家已经是非法的，在乌干达有无期徒刑的条件。

> 虽然我不认同同性恋，但也没必要判死刑吧？

### [专家说，如果没有新法律，TikTok 将很难在美国被禁止](https://bag.frp.aqzscn.cn/share/641c85a9cb4b11.47097492)

![](https://bag.frp.aqzscn.cn/assets/images/e/2/e28ebb35/8c25690b.jpeg)

由于对审查制度、用户影响以及美国个人数据可能被传递到北京的担忧，拜登政府面临着禁止中国社交媒体应用程序 TikTok 的压力。然而，任何禁令都将取决于新法律的通过，这些法律将赋予政府更严格的言论监督权。 RESTRICT ACT 是本月推出的一项两党法案，被建议作为绕过言论自由保护的可能途径，但它的采纳尚不确定。 TikTok 首席执行官周寿子周四将面临立法者关于该应用程序的提问。

> Tik Tok 可太难了，不过封不封它我倒是无所谓，只是确实不能只封一个 APP 呀，这样不能服众。最好像我国一样，建一座长城，或者通过一个法律，对所有外国公司一视同仁。

### [IPCC 表示，通过真正的改变，世界仍然可以避免最糟糕的气候崩溃](https://bag.frp.aqzscn.cn/share/641c859da61e18.91803339)

![](https://bag.frp.aqzscn.cn/assets/images/8/9/89e57e22/0b54cd38.jpeg)

政府间气候变化专门委员会（IPCC）表示，如果全球实现转型变革，仍有可能避免气候变化造成的最严重破坏。 IPCC 表示，虽然极端天气已经造成了重大破坏，但人类有能力在应对气候变化的同时建设一个更加繁荣和包容的社会。向低碳经济转型需要的资金水平是目前用于绿色投资的资金水平的三到六倍。气候正义也很重要，因为最贫穷和最脆弱的人首当其冲地受到气候变化的影响。 IPCC 的最终报告还确定了大幅减排的必要性，强调如果目前的排放率继续下去，1.5C 的碳预算将在 2030 年耗尽。该报告可能是 IPCC 十年来的最后一份报告。

> 短视的人类啊。

### [和平计划和管道：普京与习会谈的结果是什么？](https://bag.frp.aqzscn.cn/share/641c8538d72729.21785442)

![](https://bag.frp.aqzscn.cn/assets/images/5/f/5f5dcf8f/67866097.jpeg)
俄罗斯总统弗拉基米尔·普京 (Vladimir Putin) 在莫斯科会见了中国国家主席习近平，举行了为期两天的峰会，达成了 14 项协议，涉及的主题从大豆到原子能。虽然峰会的联合声明呼应了中国上个月呼吁对话的 12 点文件中的措辞，但并未提及尊重所有国家的领土完整。不过，它确实警告不要“集团对抗”，并谴责单边制裁。领导人讨论了乌克兰问题，普京表示，中国的提议可以作为和平解决的基础，但会议没有出现任何在军事上束缚他手脚的东西。两位领导人还讨论了潜在的新天然气管道“西伯利亚力量 2”，该管道将额外输送 500 亿立方米的俄罗斯天然气，但未达成任何协议。强调了普京和习近平之间关系的私人性质，因为他们已经会面了大约 40 次，并称对方为“亲爱的朋友”。总体而言，此次峰会符合普京的目的，即允许他继续在乌克兰作战，同时表明他愿意谈论和平。

### [“3・21”东航 MU5735 客机飞行事故调查进展情况通报发布 - IT 之家](https://bag.frp.aqzscn.cn/share/641d8cb8754192.94738030)

2022 年 3 月 21 日，东航一架波音 737 客机在执行昆明至广州航班时在梧州上空坠毁，机上 123 名乘客和 9 名机组人员全部遇难。今天，在事故发生一周年之际，中国民航局发布了事故调查进展情况通报。调查细致而严谨，对飞机残骸进行了详细检查，进行了实验和分析。但由于事故的复杂性和罕见性，调查仍在进行中，工作组将继续开展原因分析、实验验证等工作，及时发布相关信息。

> 公布了个寂寞，飞行员有心理问题有那么难说出口吗（我臆断的，毕竟连个录音都是国家机密听不得）？

## ⭐️ 收藏

### [RapidAPI - 原名 Paw，用于测试并调试 API，目前已免费[macOS] - 小众软件](https://bag.frp.aqzscn.cn/share/641d8c7bcb2b30.13398622)

![](https://bag.frp.aqzscn.cn/assets/images/a/7/a7df9fa7/ad4311fe.jpeg)

RapidAPI（以前称为 Paw）是一个免费的 macOS 应用程序，允许 Web 开发人员测试和调试 API 接口。它提供了广泛的功能，例如模拟请求、测试响应、查看 API 信息，并支持常见的 API 调用方法，如 GET、POST、PUT、PATCH 和 DELETE。此外，它支持 OAuth 和大多数身份验证，提供动态值，并可以将请求和响应数据导出为不同的文件格式。 RapidAPI 还集成了其他应用程序和服务，如 Slack、Flowdock、Charles 和 Fiddler。总的来说，它是一款功能强大的工具，对于 Mac 计算机上的开发人员、测试人员和 API 集成人员来说易于使用。

### [使用 Docker 搭建图形化 Clash 服务端支持自动更新订阅](https://bag.frp.aqzscn.cn/share/641d8c661244b8.89880498)

![](https://bag.frp.aqzscn.cn/assets/images/a/d/ad7f119b/c07885a0.png)

需要采取以下步骤来准备部署订阅节点：

1、根据自己的情况修改配置文件（config.yaml），包括代理设置、模式、日志输出级别、DNS 设置、代理节点、代理组策略、规则提供者、导流规则。 2. 下载第三方用户界面（如 yacd）并将其解压到名为“ui”的文件夹中，该文件夹与 config.yaml 文件位于同一目录中。 3. 使用 Docker 命令或 Docker Compose 部署订阅节点。如果使用 Docker Compose，请创建一个 docker-compose.yaml 文件并指定图像、容器名称、卷、端口和网络模式。然后，运行命令“docker-compose up -d”开始部署。 4. 查看日志输出，验证部署是否成功。访问位于 http://IP:8090/ui 的控制面板以查看和管理代理设置。

> 我还在墙边徘徊，想把我的周报脚本更加自动化一点可太难了。
